define("modules/dialog_manager",["require","modules/panel_cache","shared/lazy_loader"],function(e){var t=e("modules/panel_cache"),n=e("shared/lazy_loader"),i=function(){this.OVERLAY_SELECTOR=".settings-dialog-overlay",this._overlayDOM=document.querySelector(this.OVERLAY_SELECTOR)};i.prototype={_loadPanel:function(e){var t=new Promise(function(t){var i=document.getElementById(e);if(i.dataset.rendered)return t(),void 0;if(i.dataset.rendered=!0,i.dataset.requireSubPanels){for(var o='section[id^="'+i.id+'-"]',s=document.querySelectorAll(o),a=0,r=s.length;r>a;a++)n.load([s[a]]);n.load([i],t)}else n.load([i],t)});return t},_initializedL10n:function(){var e=new Promise(function(e){navigator.mozL10n.once(e)});return e},_getPanel:function(e){var n=new Promise(function(n){t.get(e,function(e){n(e)})});return n},_showOverlay:function(e){this._overlayDOM.hidden=!e},_transit:function(e,t){var n=new Promise(function(n){var i=t.panel;i.addEventListener("transitionend",function o(t){"close"!==e&&"open"!==e||"visibility"!==t.propertyName||("close"===e&&(i.hidden=!0),i.removeEventListener("transitionend",o),n())}),"open"===e&&(i.hidden=!1),setTimeout(function(){"open"===e?i.classList.add("current"):i.classList.remove("current")},150)});return n},_open:function(e,t){var n,i=this;return Promise.resolve().then(function(){return i._loadPanel(e.panel.id)}).then(function(){return i._initializedL10n()}).then(function(){return i._getPanel(e.panel.id)}).then(function(i){return n=i,n.beforeShow(e.panel,t)}).then(function(){return e.init(),e.initUI(),e.bindEvents(),"zoom-in-80"===e.TRANSITION_CLASS&&i._showOverlay(!0),i._transit("open",e,t)}).then(function(){return n.show(e.panel,t)})},_close:function(e,t){var n,i,o=this;return Promise.resolve().then(function(){return o._getPanel(e.panel.id)}).then(function(e){n=e;var i;return i=n.onSubmit&&"submit"===t._type?n.onSubmit():n.onCancel&&"cacnel"===t._type?n.onCancel():Promise.resolve()}).then(function(e){return i=e,n.beforeHide()}).then(function(){return o._transit("close",e,t)}).then(function(){var t;return"prompt-dialog"===e.DIALOG_CLASS?t=e.getResult():i&&(t=i),e.cleanup(),"zoom-in-80"===e.TRANSITION_CLASS&&o._showOverlay(!1),t})},_navigate:function(e,t,n){return e="open"===e?"_open":"_close",this[e](t,n)},open:function(e,t){return this._navigate("open",e,t)},close:function(e,t,n){return n._type=t,this._navigate("close",e,n)}};var o=new i;return o}),define("modules/dialog/base_dialog",["require"],function(){var e=function(e,t){this.panel=e,this._options=t||{}};return e.prototype.DIALOG_CLASS="dialog",e.prototype.TRANSITION_CLASS="fade",e.prototype.SUBMIT_BUTTON_SELECTOR='[type="submit"]',e.prototype.CANCEL_BUTTON_SELECTOR='[type="reset"]',e.prototype.MESSAGE_SELECTOR=".settings-dialog-message",e.prototype.TITLE_SELECTOR=".settings-dialog-title",e.prototype.init=function(){this.TRANSITION_CLASS=this._options.transition||this.TRANSITION_CLASS,this.panel.classList.add(this.DIALOG_CLASS),this.panel.classList.add(this.TRANSITION_CLASS)},e.prototype.initUI=function(){var e=this._options.message,t=this._options.title,n=this._options.submitButton,i=this._options.cancelButton;this._updateMessage(e),this._updateTitle(t),this._updateSubmitButton(n),this._updateCancelButton(i)},e.prototype.bindEvents=function(){var e=this;this.getSubmitButton().onclick=function(){e._options.onWrapSubmit()},this.getCancelButton().onclick=function(){e._options.onWrapCancel()}},e.prototype._updateMessage=function(e){var t=this.panel.querySelector(this.MESSAGE_SELECTOR);t&&e&&(e=this._getWrapL10nObject(e),navigator.mozL10n.setAttributes(t,e.id,e.args))},e.prototype._updateTitle=function(e){var t=this.panel.querySelector(this.TITLE_SELECTOR);t&&e&&(e=this._getWrapL10nObject(e),navigator.mozL10n.setAttributes(t,e.id,e.args))},e.prototype._updateSubmitButton=function(e){var t=this.getSubmitButton();t&&e&&(e=this._getWrapL10nObject(e),navigator.mozL10n.setAttributes(t,e.id,e.args),t.className=e.style||"recommend")},e.prototype._updateCancelButton=function(e){var t=this.getCancelButton();t&&e&&(e=this._getWrapL10nObject(e),navigator.mozL10n.setAttributes(t,e.id,e.args),t.className=e.style||"")},e.prototype._getWrapL10nObject=function(e){if("string"==typeof e)return{id:e,args:null};if("object"==typeof e){if("undefined"==typeof e.id)throw new Error("You forgot to put l10nId - "+JSON.stringify(e));return{id:e.id,args:e.args||null,style:e.style}}throw new Error("You are using the wrong L10nObject, please check its format again")},e.prototype.getDOM=function(){return this.panel},e.prototype.getSubmitButton=function(){return this.panel.querySelector(this.SUBMIT_BUTTON_SELECTOR)},e.prototype.getCancelButton=function(){return this.panel.querySelector(this.CANCEL_BUTTON_SELECTOR)},e.prototype.cleanup=function(){"panel-dialog"!==this.DIALOG_CLASS&&(this._updateTitle("settings-"+this.DIALOG_CLASS+"-header"),this._updateSubmitButton("ok"),this._updateCancelButton("cancel")),this.panel.classList.remove(this.DIALOG_CLASS),this.panel.classList.remove(this.TRANSITION_CLASS)},e}),define("modules/dialog/panel_dialog",["require","modules/dialog/base_dialog"],function(e){var t=e("modules/dialog/base_dialog"),n=function(e,n){t.call(this,e,n)};return n.prototype=Object.create(t.prototype),n.prototype.constructor=n,n.prototype.DIALOG_CLASS="panel-dialog",n.prototype.TRANSITION_CLASS="fade",function(e,t){return new n(e,t)}}),define("modules/dialog/alert_dialog",["require","modules/dialog/base_dialog"],function(e){var t=e("modules/dialog/base_dialog"),n=function(e,n){t.call(this,e,n)};return n.prototype=Object.create(t.prototype),n.prototype.constructor=n,n.prototype.DIALOG_CLASS="alert-dialog",n.prototype.TRANSITION_CLASS="fade",n.prototype.bindEvents=function(){var e=this;this.getSubmitButton().onclick=function(){e._options.onWrapSubmit()}},function(e,t){return new n(e,t)}}),define("modules/dialog/confirm_dialog",["require","modules/dialog/base_dialog"],function(e){var t=e("modules/dialog/base_dialog"),n=function(e,n){t.call(this,e,n)};return n.prototype=Object.create(t.prototype),n.prototype.constructor=n,n.prototype.DIALOG_CLASS="confirm-dialog",n.prototype.TRANSITION_CLASS="fade",n.prototype.bindEvents=function(){var e=this;this.getSubmitButton().onclick=function(){e._options.onWrapSubmit()},this.getCancelButton().onclick=function(){e._options.onWrapCancel()}},function(e,t){return new n(e,t)}}),define("modules/dialog/prompt_dialog",["require","modules/dialog/base_dialog"],function(e){var t=e("modules/dialog/base_dialog"),n=function(e,n){t.call(this,e,n)};return n.prototype=Object.create(t.prototype),n.prototype.constructor=n,n.prototype.DIALOG_CLASS="prompt-dialog",n.prototype.TRANSITION_CLASS="fade",n.prototype.INPUT_SELECTOR=".settings-dialog-input",n.prototype.bindEvents=function(){var e=this;this.getSubmitButton().onclick=function(){e._options.onWrapSubmit()},this.getCancelButton().onclick=function(){e._options.onWrapCancel()}},n.prototype.initUI=function(){t.prototype.initUI.call(this),this.getInput().value=this._options.defaultValue||""},n.prototype.getInput=function(){return this.panel.querySelector(this.INPUT_SELECTOR)},n.prototype.getResult=function(){return this.getInput().value},function(e,t){return new n(e,t)}}),define("modules/dialog_service",["require","settings","modules/defer","modules/dialog_manager","modules/dialog/panel_dialog","modules/dialog/alert_dialog","modules/dialog/confirm_dialog","modules/dialog/prompt_dialog"],function(e){var t=e("settings"),n=e("modules/defer"),i=e("modules/dialog_manager"),o=e("modules/dialog/panel_dialog"),s=e("modules/dialog/alert_dialog"),a=e("modules/dialog/confirm_dialog"),r=e("modules/dialog/prompt_dialog"),c=function(){this._navigating=!1,this._pendingRequests=[],this._settingsAlertDialogId="settings-alert-dialog",this._settingsBaseDialogId="settings-base-dialog",this._settingsConfirmDialogId="settings-confirm-dialog",this._settingsPromptDialogId="settings-prompt-dialog"};c.prototype={alert:function(e,t){var n=t||{};return this.show(this._settingsAlertDialogId,{type:"alert",message:e,title:n.title,submitButton:n.submitButton})},confirm:function(e,t){var n=t||{};return this.show(this._settingsConfirmDialogId,{type:"confirm",message:e,title:n.title,submitButton:n.submitButton,cancelButton:n.cancelButton})},prompt:function(e,t){var n=t||{};return this.show(this._settingsPromptDialogId,{type:"prompt",message:e,title:n.title,defaultValue:n.defaultValue,submitButton:n.submitButton,cancelButton:n.cancelButton})},show:function(e,c,l){var u,d,p=this,h=document.getElementById(e),f=t.currentPanel,m=c||{};if(u=l?l:n(),this._navigating)this._pendingRequests.push({defer:u,panelId:e,userOptions:c});else if("#"+e===f)u.reject("You are showing the same panel #"+e);else{switch(m.onWrapSubmit=function(){i.close(d,"submit",m).then(function(e){u.resolve({type:"submit",value:e}),p._navigating=!1,p._execPendingRequest()})},m.onWrapCancel=function(){i.close(d,"cancel",m).then(function(e){u.resolve({type:"cancel",value:e}),p._navigating=!1,p._execPendingRequest()})},m.type){case"alert":d=s(h,m);break;case"confirm":d=a(h,m);break;case"prompt":d=r(h,m);break;default:d=o(h,m)}this._navigating=!0,i.open(d,m)}return u.promise},_execPendingRequest:function(){var e=this._pendingRequests.pop();e&&this.show(e.panelId,e.userOptions,e.defer)}};var l=new c;return l});